Program Aphor;
{----------------------------------------------------------------------|
| Reads and displays paragraphs from the files APHORn.TXT. See the
| beginning of these files for the description of the structure of a
| file. APHOR.IPI contains the numbers of the next file and quotation
| to be selected. All APHOR*.* files must be in the same directory.
|
| Parameters: none
|
| TurboPascal 5.0, 1998-10-3, revised 1999-1-8.
|----------------------------------------------------------------------|
}
{$N- }
  uses
     CRT;
  type
     linestyle = (top, body, bott);
  const
     director = 'c:\aphordir\';
  var
     cf, ce, tn, kk, tlen, ty: integer;
     buf: array[1 .. $4000] of byte;
     kx: boolean;
     tt: array[1 .. 9] of string[80];
     pre: string;

  procedure PutLine(linsty: linestyle);
{
| Graphical symbols for drawing a frame.
}
  const
     ul = #$C9; ur = #$BB; ll = #$C8; lr = #$BC; hl = #$CD; vl = #$BA;
     tab = Chr(9);
  var
     ii, jj: integer;
  begin
     case linsty of
     top :  begin
               TextBackGround(7);
               TextColor(15);
               Write(' ', ul); for ii := 3 to 78 do Write(hl);
               Write(ur, ' '); {it 's crazy, I know}
               WriteLn(' ', vl, vl:77);
            end;
     body : begin
               Write(' ', vl, '  ');
               Write(pre, tt[ty]);
               GoToXY(79, WhereY); Writeln(vl);
            end;
     bott : begin
               WriteLn(' ', vl, vl:77);
               Write(' ', ll); for ii := 3 to 78 do Write(hl);
               Write(lr);
               TextBackGround(0);
               TextColor(15);
               WriteLn;
            end;
     end;
  end;

  procedure WriteHelp;
  const
     nnlen = 6;
     nn: array[1..nnlen] of string[68] = (
     '    APHOR reads and displays paragraphs from the files          ',
     '    APHORnn.TXT. nn is a number. See the beginning of file      ',
     '    APHOR1.TXT for a description of the structure of this file. ',
     '    The current file number and quotation number are contained  ',
     '    in APHOR.IPI. All APHOR-files must be in the directory      ',
     '    C:\APHORDIR\                                                ');
     
  var
     ii: byte;

  begin
     for ii := 1 to nnlen do Writeln(nn[ii]);
     Writeln;
     Halt;
  end;

  function OpenRead: boolean;
  const
     filename = director + 'Aphor';
  var
     ss: string[4];
     nb, cn: integer;
     inifile: text;
     infile: file;
  begin
{
| Read .IPI file
}
  {$I-}
  Assign(inifile, filename + '.ipi'); Reset(inifile);
  if IOResult <> 0 then begin
     {$I+}
     Rewrite(inifile);
     cf := 1;
     ce := 1;
     Writeln(inifile, cf:5, ce:5);
     Writeln('+++ new Aphor.ipi written.'); end
  else
     Readln(inifile, cf, ce);
  IF cf < 1 then cf := 1;
  Close(inifile);
{
| Read textfile.
}
  {$I-}
  Str(cf, ss);
  Assign(infile, filename + ss + '.txt'); Reset(infile);
  if IOResult <> 0 then begin
     Assign(infile, filename + '1.txt'); Reset(infile);
     if IOResult <> 0 then begin
        Writeln('### no Aphor textfile found.');
        Halt; end
     else begin
        cf := 1;
        ce := 1;
     end;
  end;

  {$I+}
  FillChar(buf, $4000, $0);
  BlockRead(infile, buf, 128, nb);
  Close(infile);
  nb := (nb + 1) * 128;
  kk := 1;
  cn := 0;
  Repeat
     if buf[kk] = 9 then begin
        Inc(cn);
     end;
     Inc(kk, 2);
  Until ((cn = ce) OR (kk >= nb));

  if cn < ce then begin
     Inc(cf);
     ce := 1;
     OpenRead := false; end
  else begin
     Inc(ce);
     Openread := true;
  end;
  Assign(inifile, filename + '.ipi'); Rewrite(inifile);
  Writeln(inifile, cf:5, ce:5);
  Close(inifile);
  end;

  procedure ShowPara;
  var
     flag: boolean;
     bb, jj: byte;

  begin
  while buf[kk] <> 10 do Inc(kk);
  Inc(kk);
  flag := false;
  tn := 1;
  tt[1] := '';
  tlen := 0;
  repeat
     bb := buf[kk];
     if bb = 13 then begin
        if tt[tn][1] <> '!' then
        if Length(tt[tn]) > tlen then tlen := Length(tt[tn]);
        Inc(tn);
        tt[tn] := '';
        Inc(kk); end
     else if bb = 9 then
        flag := true
     else
        tt[tn] := tt[tn] + CHR(bb);
     Inc(kk);
  Until ((bb = 13) and flag);
  Dec(tn);
  Insert('          ', tt[tn], 1);
  if Length(tt[tn]) > tlen then tlen := Length(tt[tn]);
  pre := '';
  repeat
     pre := pre + ' ';
  until Length(pre) = (72 - tlen) div 2;

  PutLine(top);
  for jj := 1 to tn do begin
     ty := jj;
     if tt[jj][1] <> '!' then PutLine(body);
  end;
  PutLine(bott);
  end;
{
| Aphor main.
}
  begin
     if ParamCount > 0 then begin
        WriteHelp;
     end;
{
| Open text file.
}
  Repeat
     kx := OpenRead;
  Until kx;
  ShowPara;
  end.